Bug 1289022 - VLAs not protected with -fstack-protector
Summary: VLAs not protected with -fstack-protector
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: gcc   
(Show other bugs)
Version: 7.3
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: 7.3
Assignee: Jakub Jelinek
QA Contact: Michael Petlan
Tomas Capek
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 1297579 1313485
TreeView+ depends on / blocked
 
Reported: 2015-12-07 09:17 UTC by Jakub Jelinek
Modified: 2017-02-16 13:38 UTC (History)
4 users (show)

Fixed In Version: gcc-4.8.5-6.el7
Doc Type: Bug Fix
Doc Text:
Better stack protection in GCC Prior to this update, GCC stack protection did not work for functions that only contained variable-length arrays and no other (or only very small) arrays. Consequently, a buffer overflow error could occur undetected. This bug has been fixed and the compiler is now able to instrument even such functions.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-11-04 06:27:17 UTC
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2016:2433 normal SHIPPED_LIVE gcc bug fix and enhancement update 2016-11-03 14:01:11 UTC
GNU Compiler Collection 68680 None None None Never

Description Jakub Jelinek 2015-12-07 09:17:07 UTC
In GCC 4.7+, gcc mistakenly does not stack protect functions that contain just a variable length array and no other (or only very small) arrays.
See http://gcc.gnu.org/PR68680 for details, just use -fstack-protector instead of -fstack-protector-strong.

E.g. -O2 -fstack-protector:

int process(char *);

int
uses_vla(unsigned long sz)
{
  char buf[sz];
  return process(buf);
}

Comment 3 Michael Petlan 2016-07-25 09:48:51 UTC
test fails with gcc-4.8.5-4.el7
test passes for gcc-4.8.5-9.el7

VERIFIED

Comment 5 errata-xmlrpc 2016-11-04 06:27:17 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHBA-2016-2433.html


Note You need to log in before you can comment on or make changes to this bug.